
#include "svf/svfrun.h"
#include "mlink/regiomlink.h"
#include "mlink/exc.h"
#include "mlink/jtag_impl.h"
#include "mlink/Jtag_Impl_Tracer.h"
#include <boost/shared_ptr.hpp>
#include <iostream>
#include <fstream>
#include <string>

using namespace mlink;

int main(int argc, char *argv[]) {

  std::string fileName;
  if (argc == 2) {
    fileName = argv[1];
  } else {
    std::cerr << "Usage: " << argv[0] << " <filename>" << std::endl << std::endl;
    exit(EXIT_FAILURE);
  }
  try {
    boost::shared_ptr<Jtag_Impl> jtagImpl(new Jtag_Impl_Tracer());
    jtagImpl->setTracing(true);
    SvfRun parser(jtagImpl, fileName);
    parser.exec(SvfRun::NoCheckTdoException);
    std::cout << "Success" << std::endl;
    {
      std::ofstream ofs;
      ofs.open("svftest.txt");
      ofs << jtagImpl->getTrace();
      ofs.close();
    }
  }
  catch (std::exception &e) {
    std::cerr << "Exception: " << e.what() << std::endl;
    return EXIT_FAILURE;
  }

  return EXIT_SUCCESS;
}
